

import java.awt.*;
import javax.swing.*;
import java.util.*;
import java.util.Random;

import java.util.ArrayList;
import java.util.Iterator;


//AWT-EventQueue-0
//http://kin.naver.com/qna/detail.nhn?d1id=1&dirId=1040201&docId=241836507&qb=SmF2YSByYW5k&enc=utf8&section=kin&rank=1&search_sort=0&spq=0&pid=So2DcwoRR18ssvgjdQ0sssssss8-086974&sid=3ZSiXSWGS0A%2BSu/da7hOuA%3D%3D
//http://blog.naver.com/robinnw/80211544638
//http://blog.naver.com/kdw9242/70139152463
//https://opentutorials.org/module/1335/8711



class SnowBallThread extends Thread
{
    ArrayList<Point> snow;//  

    public SnowBallThread(ArrayList<Point> snow)
    {
        this.snow = snow;
    }
    
    public void run()
    {
        Random rand = new Random();
        
        while (true)
        {
            try
            {
                synchronized(this)
                {
                    Point point = new Point(rand.nextInt(500), 0);//
                    snow.add(point);//  
                }
                Thread.sleep(300);
            }
            catch (InterruptedException e)
            {
                System.out.println("SnowBallThread run");
                return;
            }
        }
    }
}

class SnowThread extends JFrame
{

    SnowBallThread th;
    BackPanel backGround;

    Random rand = new Random();
    ArrayList<Point> snow = new ArrayList<Point>();

    public SnowThread()
    {
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setTitle("SnowThread ");
        backGround = new BackPanel();
        setContentPane(backGround);
        setSize(500, 440);
        setLocation(200, 200);
        setVisible(true);
        backGround.requestFocus();
        th = new SnowBallThread(snow);// ϱ  snow 忡 ־
        th.start();

        Thread t = new Thread(backGround);// ̱  
        t.start();
    }

    public class BackPanel extends JPanel implements Runnable
    {

        Image imgSample;

        public BackPanel()
        {
            setLayout(null);
            ImageIcon icon = new ImageIcon("image.png");
            imgSample = icon.getImage();
        }

        public void paintComponent(Graphics g)
        {
            super.paintComponent(g);
            g.drawImage(imgSample, 0, 0, getWidth(), getHeight(), null);
            
            synchronized(this)
            {
                int i;
                int size = snow.size();
                for(i=0; i<size; i++)
                {
                    Point p = snow.get(i);
                    g.setColor(Color.white);//Ͼ
                    g.fillOval(p.x, p.y, 5, 5);//ġ 5ũ ׸
                }
            }
        }

        public void run()
        {
            while (true)
            {
                try
                {
                    synchronized(this)
                    {
                        int i;
                        int size = snow.size();
                        for(i=0; i<size; i++)
                        {
                            Point p = snow.get(i);
                            p.x = rand.nextInt(500);
                            p.y += 3;
                            
                            if (p.y > 440)//ȭ   
                            {
                                snow.remove(i);
                                break;
                            }
                        } 
                    }
                    repaint();//ȭ    
                    Thread.sleep(50);
                }
                catch (InterruptedException e)
                {
                    System.out.println("SnowThread run");
                    return;
                }
            }
        }
    }

    public static void main(String[] args)
    {
        new SnowThread();
    }
}

